<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.16.2.4 $
 * $Author: tora60 $
 * $Date: 2007/12/27 17:28:25 $
 */

/**
 * How to use the rss-syndication file ?
 * Simple: In your RSS-Reader use this URL:
 * http://www.YourDomain.tld/backend.php
 * then you will get from all sources (stories,downloads,links,eboard)
 * in $limit limited ammount of news in RSS1.0 Format
 * to specify one source you have to add ?op=sourcename after the
 * backend.php where sourcename ca be one of story,downs,link or board
 * eg http://www.YourDomain.tdl/backend.php?op=downs for Download
 * to specify a Feed-format, add a version=XXX where xxx can be one of
 * RSS0.91, RSS1.0, RSS2.0, OPML, mbox, PIE0.1, JS, HTML or ATOM0.3
 * eg http://www.YourDomain.tdl/backend.php?version=RSS2.0 for RSS2.0
 * to select one or more of the sources use following syntax:
 * http://www.YourDomain.tdl/backend.php?op=auswahl&feed1=XXX[&feed2=XXX&feed3=XXX]
 * where XXX can be one of story,downs,link or board also in this case
 * you can add the format at the end (&version=XXX)
 *
 * Thanks to Musicman75 (http://www.gothic-online.de) for writing the Kalender RSS function
 */

/*
 * eventuelle Ausgaben zwischenspeichern, um sie am Ende, evtl.
 * wieder als html-Kommentar anzufuegen
 */
ob_start();

/* festlegen, dass der Page-Restrictor nicht aktiviert wird */
define('mxDontLoadPageRestritor', true);

/* System */
include_once('mainfile.php');

/* Fehlerausgaben komplett unterdruecken */
error_reporting(0);

if (empty($backend_active)) {
    die('sorry, rss-feed is not active');
}
include_once("includes/feedcreator.class.php");

/**
 * URL zur Logo-Bilddatei (ohne fhrenden Slash und ohne Domainangabe
 */
$logo = $backend_logo;
if (is_file($backend_logo)) {
    $logo = $backend_logo;
}
// / die folgenden Einstellungen knnen durch _GET Parameter berschrieben werden
/**
 * wieviel einzelne Punkte in den jeweiligen feeds anzeigen (15 maximal !) = _GET[limit]
 */
$limit = intval($backend_limit);
if (isset($_GET['limit']) && is_numeric($_GET['limit']) && $_GET['limit'] > 0 && $_GET['limit'] < 16) {
    $limit = intval($_GET['limit']);
}
/**
 * max. Angezeigte Lnge der RSS-Beschreibung                              = _GET[rdt]
 */
$rssdecriptiontrunk = intval($backend_rssdecriptiontrunk);
if (isset($_GET['rdt']) && is_numeric($_GET['rdt']) && $_GET['rdt'] > 0) {
    $rssdecriptiontrunk = intval($_GET['rdt']);
}
/**
 * max. Angezeigte Lnge der Image-Beschreibung                            = _GET[pdt]
 */
$imagedescriptiontrunk = intval($backend_imagedescriptiontrunk);
if (isset($_GET['pdt']) && is_numeric($_GET['pdt']) && $_GET['pdt'] > 0) {
    $imagedescriptiontrunk = intval($_GET['pdt']);
}
/**
 * max. Angezeigte Lnge der einzelnen Item-Beschreibung                   = _GET[idt]
 */
$itemdescriptiontrunk = intval($backend_itemdescriptiontrunk);
if (isset($_GET['idt']) && is_numeric($_GET['idt']) && $_GET['idt'] > 0) {
    $itemdescriptiontrunk = intval($_GET['idt']);
}
// ## global informations for rss-syndication
$rss = new UniversalFeedCreator();
// $rss->useCached();
$rss->descriptionTruncSize = $rssdecriptiontrunk;
$rss->descriptionHtmlSyndicated = false;
$rss->title = htmlspecialchars($sitename);
$rss->description = htmlspecialchars($backend_title);
$rss->language = $backend_language;
$rss->link = MX_HOME_URL . '/';
$rss->syndicationURL = MX_HOME_URL . '/' . basename(__file__);
$image = new FeedImage();
$image->descriptionTruncSize = $imagedescriptiontrunk;
$image->descriptionHtmlSyndicated = false;
$image->title = $sitename . "-Logo";
$image->url = MX_HOME_URL . "/" . $logo;
$image->link = MX_HOME_URL . '/';
$image->description = "Feed provided by " . MX_HOME_URL . ". Click to visit.";
$rss->image = $image;
// ## end global informations
$modules = sql_query("SELECT title, active FROM " . $prefix . "_modules");
while (list($modulename, $modulactive) = sql_fetch_row($modules)) {
    $modcheck[$modulename] = $modulactive;
}

$actions = array("news", "story", "downs", "board", "link", "auswahl", "calendar", "reviews", "all");
$versions = array("RSS0.91", "RSS1.0", "RSS2.0", "OPML", "mbox", "PIE0.1", "ATOM0.3", "HTML", "JS");

function stories ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck;
    $heute = time();
    $result = sql_query("SELECT sid, title, hometext, UNIX_TIMESTAMP(time)AS date, informant FROM " . $prefix . "_stories where (UNIX_TIMESTAMP(time) <= " . $heute . ")  ORDER BY `time` DESC, `sid` DESC limit " . $limit);
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("News")) && ($modcheck['News'])) {
            while ($data_stories = sql_fetch_object($result)) {
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags (rss_bbencode($data_stories->title));
                $item->link = MX_HOME_URL . "/modules.php?name=News&file=article&sid=" . $data_stories->sid;
                $item->description = strip_tags (rss_bbencode($data_stories->hometext));
                $item->date = intval($data_stories->date);
                $item->source = MX_HOME_URL . "/modules.php?name=News";
                // $item->author = $data_stories->informant;
                $rss->addItem($item);
            }
        } else {
            moduleerror("News");
        }
    }
}

function eBoard ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck ;
    if (!@include("modules/eBoard/settings.php")) {
        moduleerror("eBoard");
        return;
    }
    $result = sql_query("SELECT a.tid, a.subject, a.message, a.lastpost, a.dateline, b.private, b.userlist FROM " . $table_threads . " AS a LEFT JOIN " . $table_forums . " AS b ON a.fid =b.fid WHERE private='' AND userlist='' ORDER BY a.lastpost DESC limit " . $limit);
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("eBoard")) && ($modcheck['eBoard'])) {
            while ($data_board = sql_fetch_object($result)) {
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags(rss_bbencode($data_board->subject));
                $item->link = MX_HOME_URL . "/modules.php?name=eBoard&file=viewthread&tid=" . $data_board->tid;
                $item->description = strip_tags(rss_bbencode($data_board->message));
                $datum = substr($data_board->lastpost, 0, (strpos($data_board->lastpost, "|")));
                $informant = substr(strrchr($data_board->lastpost, "|"), 1);
                $item->date = intval($datum);
                $item->source = MX_HOME_URL . "/modules.php?name=eBoard";
                // $item->author = $informant;
                $rss->addItem($item);
            }
        } else {
            moduleerror("eBoard");
        }
    }
}

function links ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck ;
    $result = sql_query("select lid, title, description, UNIX_TIMESTAMP(date)AS datum, submitter from " . $prefix . "_links_links ORDER BY date DESC limit " . $limit);
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("Web_Links")) && ($modcheck['Web_Links'])) {
            while ($data_links = sql_fetch_object($result)) {
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags(rss_bbencode($data_links->title));
                $item->link = MX_HOME_URL . "/modules.php?name=Web_Links&op=view&lid=" . $data_links->lid;
                $item->description = strip_tags(rss_bbencode($data_links->description));
                $item->date = intval($data_links->datum);
                $item->source = MX_HOME_URL . "/modules.php?name=WebLinks";
                // $item->author = $data_links->submitter;
                $rss->addItem($item);
            }
        } else {
            moduleerror("Web_Links");
        }
    }
}

function downloads ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck ;
    $result = sql_query("select lid, title, description, UNIX_TIMESTAMP(date)AS datum, submitter from " . $prefix . "_downloads_downloads WHERE cid > 0 ORDER BY date DESC limit " . $limit);
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("Downloads")) && ($modcheck['Downloads'])) {
            while ($data_down = sql_fetch_object($result)) {
                if (($version == "RSS1.0")or($version == "RSS2.0")) {
                    $data_down->description = rss_bbencode($data_down->description);
                    $data_down->title = rss_bbencode($data_down->title);
                }
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags(rss_bbencode($data_down->title));
                $item->link = MX_HOME_URL . "/modules.php?name=Downloads&op=view&lid=" . $data_down->lid;
                $item->description = strip_tags(rss_bbencode($data_down->description));
                $item->date = intval($data_down->datum);
                $item->source = MX_HOME_URL . "/modules.php?name=Downloads";
                // $item->author = $data_down->submitter;
                $rss->addItem($item);
            }
        } else {
            moduleerror("Downloads");
        }
    }
}

function reviews ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck ;
    $result = sql_query("select id, title, text, UNIX_TIMESTAMP(date)AS datum, reviewer from " . $prefix . "_reviews WHERE id > 0 ORDER BY date DESC limit " . $limit);
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("Reviews")) && ($modcheck['Reviews'])) {
            while ($data_down = sql_fetch_object($result)) {
                if (($version == "RSS1.0")or($version == "RSS2.0")) {
                    $data_down->text = rss_bbencode($data_down->text);
                    $data_down->title = rss_bbencode($data_down->title);
                }
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags(rss_bbencode($data_down->title));
                $item->link = MX_HOME_URL . "/modules.php?name=Reviews&rop=showcontent&id=" . $data_down->id;
                $item->description = strip_tags(rss_bbencode($data_down->text));
                $item->date = intval($data_down->datum);
                $item->source = MX_HOME_URL . "/modules.php?name=Reviews";
                // $item->author = $data_down->reviewer;
                $rss->addItem($item);
            }
        } else {
            moduleerror("Reviews");
        }
    }
}


function calendar ($version)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $modcheck ;

    $d = (int)Date("d");
    $m = (int)Date("m");
    $y = (int)Date("Y");
    $qrydate = "" . $y . "-" . $m . "-" . $d . "";

    $result = sql_query("SELECT eid, title, hometext, startDate, endDate FROM " . $prefix . "_events  WHERE (startDate>= '$qrydate' or endDate>= '$qrydate') ORDER BY startDate asc, endDate asc limit " . $limit . "");
    if (!$result) {
        echo "<!-- An database error occured: " . mysql_error() . " -->";
    } else {
        if ((mxModuleAllowed("Kalender")) && ($modcheck['Kalender'])) {
            while ($data_down = sql_fetch_object($result)) {
                if (($version == "RSS1.0")or($version == "RSS2.0")) {
                    $data_down->title = rss_bbencode($data_down->title);
                    $data_down->hometext = rss_bbencode($data_down->hometext);
                }
                $item = new FeedItem();
                $item->descriptionTruncSize = $itemdescriptiontrunk;
                $item->title = strip_tags(rss_bbencode("" . $data_down->startDate . " - " . $data_down->title . ""));
                $item->link = MX_HOME_URL . "/modules.php?name=Kalender&op=view&eid=" . $data_down->eid . "";
                $item->description = strip_tags(rss_bbencode($data_down->hometext));
                $item->source = MX_HOME_URL . "/modules.php?name=Kalender";
                $rss->addItem($item);
            }
        } else {
            moduleerror("Kalender");
        }
    }
}

function rss_bbencode($msg)
{
    $pattern = '#(\<(img|i?frame|object|i?layer|script|link|embed)[^\&g t;]+([[:space:]]{0,})(src|rel)([[:space:]]{0,})?=([^\>]+)?admin\.php\?[^ \>]+\>)|(\[img\](.+)?(admin\.php\?).+?\[/img\])#si';
    if (preg_match($pattern, $msg)) {
        mxErrorScreen("found malicious Code in BBCode");
    }
    $msg = preg_replace("#\[quote\](.*?)\[/quote]#si", "<TABLE BORDER=0 ALIGN=CENTER WIDTH=85%><TR><TD><font size=-1>Quote</font><HR></TD></TR><TR><TD><FONT SIZE=-1><BLOCKQUOTE>\\1</BLOCKQUOTE></FONT></TD></TR><TR><TD><HR></TD></TR></TABLE>", $msg);
    $msg = preg_replace("#\[b\](.*?)\[/b\]#si", "<B>\\1</B>", $msg);
    $msg = preg_replace("#\[i\](.*?)\[/i\]#si", "<I>\\1</I>", $msg);
    $msg = preg_replace("#\[url\](http://)?(.*?)\[/url\]#si", "<A HREF=\"http://\\2\" TARGET=\"_blank\">\\2</A>", $msg);
    $msg = preg_replace("#\[u\](.*?)\[/u\]#si", "<U>\\1</U>", $msg);
    $msg = preg_replace("#\[url=(http://)?(.*?)\](.*?)\[/url\]#si", "<A HREF=\"http://\\2\" TARGET=\"_blank\">\\3</A>", $msg);
    $msg = preg_replace("#\[email\](.*?)\[/email\]#si", "<A HREF=\"mailto:\\1\">\\1</A>", $msg);
    $msg = preg_replace("#\[img\](.*?)\[/img\]#si", "<IMG SRC=\"\\1\">", $msg);
    $matchCount = preg_match_all("#\[list\](.*?)\[/list\]#si", $msg, $matches);
    for ($i = 0; $i < $matchCount; $i++) {
        $currMatchTextBefore = preg_quote($matches[1][$i]);
        $currMatchTextAfter = preg_replace("#\[\*\]#si", "<LI>", $matches[1][$i]);
        $msg = preg_replace("#\[list\]$currMatchTextBefore\[/list\]#si", "<UL>$currMatchTextAfter</UL>", $msg);
    }
    $matchCount = preg_match_all("#\[list=([a1])\](.*?)\[/list\]#si", $msg, $matches);
    for ($i = 0; $i < $matchCount; $i++) {
        $currMatchTextBefore = preg_quote($matches[2][$i]);
        $currMatchTextAfter = preg_replace("#\[\*\]#si", "<LI>", $matches[2][$i]);
        $msg = preg_replace("#\[list=([a1])\]$currMatchTextBefore\[/list\]#si", "<OL TYPE=\\1>$currMatchTextAfter</OL>", $msg);
    }
    return($msg);
}

function moduleerror($modulename)
{
    global $rss, $limit, $prefix, $itemdescriptiontrunk, $op;
    // wenn alles ausgewaehlt, keine Fehlermeldungen generieren
    if ($op == 'all') {
        return;
    }

    $item = new FeedItem();
    $item->descriptionTruncSize = $itemdescriptiontrunk;
    $item->title = "Fehler im RSS-Feed";
    $item->link = MX_HOME_URL;
    $item->description = "Das Modul " . $modulename . " ist nicht aktiviert oder nicht fr anonyme Besucher freigegeben. Bitte whlen sie einen anderen Newsfeed";
    $item->date = intval(time());
    $item->source = MX_HOME_URL;
    // $item->author = "Administrator";
    $rss->addItem($item);
}

function auswahl ()
{
    global $actions, $version;
    $wert[] = (empty($_GET["feed1"])) ? "" : ($_GET["feed1"]);
    $wert[] = (empty($_GET["feed2"])) ? "" : ($_GET["feed2"]);
    $wert[] = (empty($_GET["feed3"])) ? "" : ($_GET["feed3"]);
    $wert[] = (empty($_GET["feed4"])) ? "" : ($_GET["feed4"]);
    $i = 0;
    while ($i < 4) {
        if (!in_array ($wert[$i], $actions)) {
            $wert[$i] = "oo";
        }
        switch ($wert[$i]) {
            case "oo":
                break;

            case "news":
            case "story":
                stories($version);
                break;

            case "board":
                eBoard($version);
                break;

            case "downs":
                downloads ($version);
                break;

            case "link":
                links($version);
                break;

            case "calendar":
                calendar($version);
                break;
			case "reviews":
				reviews($version);
				break;
        }
        $i++;
    }
    unset ($i, $wert);
}

$version = (empty($_REQUEST['version'])) ? "" : ($_REQUEST['version']);
if (!in_array($version, $versions)) {
    $version = "RSS0.91";
}
switch ($version) {
    case "RSS0.91":
    case "RSS1.0":
    case "RSS2.0":
    case "OPML":
    case "PIE0.1":
    case "HTML":
        $content_type = "text/html";
        break;
    case "mbox":
        $content_type = "text/plain";
        break;
    case "ATOM0.3":
        $content_type = "application/atom+xml";
        break;
    case "JS":
        $content_type = "text/javascript";
        break;
}

$op = (empty($_GET['op'])) ? '' : $_GET['op'];
if (!in_array($op, $actions)) {
    $op = 'story';
}
switch ($op) {
    case "news":
    case "story":
        stories($version);
        break;

    case "board":
    case "eboard":
    case "mxboard":
        eBoard($version);
        break;

    case "downs":
        downloads($version);
        break;

    case "link":
        links($version);
        break;

    case "auswahl":
        auswahl($version);
        break;

    case "calendar":
        calendar($version);
        break;
		
	case "reviews":
        reviews($version);
        break;
	

    case "all":
        stories($version);
        eBoard($version);
        downloads($version);
        links($version);
        calendar($version);
		reviews($version);
        break;
}
// by Andi: das wird bentigt fr das Link-Anzeigescript welches ich gerade baue ;-)
if (defined('MX_RSS_LIST')) {
    return;
}

header('Content-Type: ' . $content_type . '; charset=' . _CHARSET);
// Feed erstellen
$out = $rss->createFeed($version);
// Validation, geschuetzte Leerzeichen entfernen
$out = str_replace(array('&amp;nbsp;', '&nbsp;'), ' ', $out);
// Ersetzen der Links in ein suchmaschinenfreundliches Format.
// Der Ausgabepuffer wurde in mx_baseconfig explizit gestartet!
// falls doch leer, ist nix mit mod_rewrite
if (backend_modrewrite()) {
    $out = mxPrepareModRewrite($out);
}

/* eventuelle Ausgaben, als Kommentar an Ende anfuegen*/
$temp = trim(ob_get_clean());

/* Ausgabe, Ende....*/
echo trim($out);

if ($temp) {
    echo "\n<!-- " . $temp . " -->";
}

/**
 * ist mod_rewrite aktiviert?
 */
function backend_modrewrite()
{
    static $check;
    if (!isset($check)) {
        $check = false;
        if (!empty($GLOBALS['mxUseModrewrite']['anony'])) {
            if (is_file('.htaccess') && is_file('includes/mx_modrewrite.php')) {
                @include_once('includes/mx_modrewrite.php');
                $check = function_exists('mxPrepareModRewrite');
            }
        }
    }
    return $check;
}

?>